﻿using UnityEngine;
using System.Collections;

public class BlinkCanvasRenderer : MonoBehaviour
{
    public float BlinksPerSecond = 1f;
    public float OnOffRatio = 0.5f;
    public bool Realtime;

    CanvasRenderer rend;

    void OnDisable()
    {
        if (rend != null) setVisible(true);
    }

    // Update is called once per frame
    void Update()
    {
        if (BlinksPerSecond <= 0)
            return;
        if (rend == null && (rend = GetComponent<CanvasRenderer>()) == null)
            return;
        OnOffRatio = Mathf.Clamp01(OnOffRatio);
        if(OnOffRatio <= 0 || OnOffRatio >= 1)
        {
            setVisible(OnOffRatio > 0);
            return;
        }

        float t = Realtime ? Time.realtimeSinceStartup : Time.time, invBPS = 1f / BlinksPerSecond;

        t = (t % invBPS) / invBPS;
        setVisible(t <= OnOffRatio);
    }

    void setVisible(bool isVisible)
    {
        rend.SetAlpha(isVisible ? 1 : 0);
    }
}
