﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class CodeImageDB : MonoBehaviour
{
    public static CodeImageDB Inst { get; private set; }

    public int Count { get { return Sprites.Length; } }

    public Sprite[] Sprites;
    public int[] Codes;

    public void SetImage(Image image, int code)
    {
        Color c = image.color;
        if (code == 0)
            c.a = 0;
        else
        {
            c.a = 1;
            image.sprite = imageCodes[code];
        }
        image.color = c;
    }

    void Awake()
    {
        if(Inst != null)
        {
            Debug.LogError("Destroying duplicate CodeImageDB. name=" + gameObject.name);
            Destroy(gameObject);
            return;
        }
        Inst = this;

        Codes = new int[Sprites.Length];
        for (int i = 0; i < Codes.Length; i++)
            Codes[i] = i + 1;

        for (int i = 0; i < Codes.Length; i++)
            imageCodes.Add(Codes[i], Sprites[i]);
    }

    Dictionary<int, Sprite> imageCodes = new Dictionary<int, Sprite>();
}
