﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;

public class InputMoveCursor : MonoBehaviour, IPointerClickHandler
{
    public event System.Action<Vector2> OnMoveCursor;

    public void OnPointerClick(PointerEventData eventData)
    {
        var rt = transform as RectTransform;
        Vector2 localPos = eventData.pressPosition - rt.anchoredPosition;
        Debug.Log("localPos=" + localPos);

        bool result = RectTransformUtility.ScreenPointToLocalPointInRectangle(rt, eventData.pressPosition, eventData.pressEventCamera, out localPos);


        if (OnMoveCursor != null)
            OnMoveCursor(localPos);
    }
}
