﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class KeyboardBuilder : MonoBehaviour
{
    public InputMessage InputReceiver;

    // Use this for initialization
    void Start()
    {
        buildIcons();
    }

    // Update is called once per frame
    void Update()
    {

    }

    readonly List<Image> imageTemp = new List<Image>();

    void onButtonClick(int code)
    {
        InputReceiver.EnterCode(code);
    }

    void buildIcons()
    {
        int total = CodeImageDB.Inst.Count;

        imageTemp.Clear();
        GetComponentsInChildren(imageTemp);

        int count = imageTemp.Count;
        while (count > total)     // delete excess images if needed
        {
            DestroyImmediate(imageTemp[count - 1].gameObject);
            imageTemp.RemoveAt(count - 1);
            count--;
        }
        while (count < total)     // add images if needed
        {
            GameObject newImageObj = Instantiate(imageTemp[0].gameObject) as GameObject;
            newImageObj.GetComponent<RectTransform>().SetParent(imageTemp[0].rectTransform.parent, false);
            imageTemp.Add(newImageObj.GetComponent<Image>());
            count++;
        }

        for (int i = 0; i < count; i++)
        {
            imageTemp[i].sprite = CodeImageDB.Inst.Sprites[i];
            int code = CodeImageDB.Inst.Codes[i];

            var btn = imageTemp[i].GetComponent<Button>();
            btn.onClick.RemoveAllListeners();
            btn.onClick.AddListener(delegate() { onButtonClick(code); });
        }
    }
}
