﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

public static class PrintLists
{

    //public static string Print(this Array list)
    //{
    //    sb.Length = 0;
    //    foreach (var itm in list)
    //        sb.Append(itm.ToString()).Append(',');
    //    sb.Length = Math.Max(0, sb.Length - 1);
    //    return sb.ToString();
    //}

    public static string Print<T, K, V>(this T list) where T : IDictionary<K, V> { return list.Print(", "); }
    public static string Print<T, K, V>(this T list, string separator) where T : IDictionary<K, V>
    {
        var sb = getPooledSB();
        foreach (var itm in list)
            sb.Append(itm.ToString()).Append(separator);
        sb.Length = Math.Max(0, sb.Length - 1);
        return releasePooledSB(sb);
    }

    public static string Print<T>(this T list) where T : IEnumerable { return list.Print(", "); }
    public static string Print<T>(this T list, string separator) where T : IEnumerable
    {
        var sb = getPooledSB();
        foreach (var itm in list)
        {
            sb.Append(itm == null ? "nul" : itm.ToString()).Append(separator);
        }
        sb.Length = Math.Max(0, sb.Length - separator.Length);
        return releasePooledSB(sb);
    }

    static readonly List<StringBuilder> SBPool = new List<StringBuilder>(new[] { new StringBuilder() });

    private static StringBuilder getPooledSB()
    {
        StringBuilder sb = SBPool[0];
        for (int i = 0; i < SBPool.Count && sb.Length > 0; i++) sb = SBPool[i]; //loop until we find an empty SB (necessary if one Print() call ends up invoking another)
        if (sb.Length > 0) SBPool.Add(sb = new StringBuilder()); //if we never find one, create a new one. BE SURE TO SET LENGTH = 0 WHEN YOURE DONE WITH EACH SB!
        return sb;
    }
    private static string releasePooledSB(StringBuilder sb)
    {
        string ret = sb.ToString();
        sb.Length = 0;
        return ret;
    }
}

